"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _pclnDesignSystem = require("pcln-design-system");
var _propTypes = _interopRequireDefault(require("prop-types"));
var _react = _interopRequireDefault(require("react"));
var _styledComponents = _interopRequireDefault(require("styled-components"));
var _styledSystem = require("styled-system");
var _excluded = ["bg", "color", "onClose", "textStyle", "title"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var Title = (0, _styledComponents["default"])(_pclnDesignSystem.Text).withConfig({
  displayName: "ModalHeader__Title",
  componentId: "sc-1yobfb9-0"
})(["display:flex;align-items:center;"]);
var StyledCloseButton = (0, _styledComponents["default"])(_pclnDesignSystem.CloseButton).withConfig({
  displayName: "ModalHeader__StyledCloseButton",
  componentId: "sc-1yobfb9-1"
})(["height:24px;width:24px;svg{vertical-align:top;}&:focus{box-shadow:none;outline:none;}"]);
var ModalHeader = function ModalHeader(_ref) {
  var bg = _ref.bg,
    color = _ref.color,
    onClose = _ref.onClose,
    textStyle = _ref.textStyle,
    title = _ref.title,
    props = _objectWithoutProperties(_ref, _excluded);
  return /*#__PURE__*/_react["default"].createElement(_pclnDesignSystem.Flex, _extends({
    align: "center",
    alignItems: "center",
    color: color,
    bg: bg,
    height: "40px"
  }, props), title && /*#__PURE__*/_react["default"].createElement(Title, {
    textStyle: textStyle
  }, title), onClose && /*#__PURE__*/_react["default"].createElement(StyledCloseButton, {
    onClick: onClose,
    ml: "auto"
  }));
};
ModalHeader.displayName = ModalHeader;
ModalHeader.propTypes = _objectSpread(_objectSpread({}, _styledSystem.space.propTypes), {}, {
  bg: (0, _pclnDesignSystem.deprecatedColorValue)(),
  color: (0, _pclnDesignSystem.deprecatedColorValue)(),
  onClose: _propTypes["default"].func,
  textStyle: _propTypes["default"].string,
  title: _propTypes["default"].string
});
ModalHeader.defaultProps = {
  bg: 'primary.base',
  color: 'text.lightest',
  px: 3,
  textStyle: 'heading6'
};
var _default = exports["default"] = ModalHeader;