function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import { action } from '@storybook/addon-actions';
import { Box, Button, Accordion, Text } from 'pcln-design-system';
import { Menu, MenuItem } from 'pcln-menu';
import React, { useState, useRef } from 'react';
import styled from 'styled-components';
import { Modal, ModalHeader, ScrollLock, SmallModalHeader } from '../src';
import { currencies } from './mockData';
const StyledModal = styled(Modal).withConfig({
  displayName: "Modalstories__StyledModal",
  componentId: "sc-14z4vs9-0"
})(["height:", ";"], props => props.height);
const CUSTOM_ANIMATION = transitionState => `
  transform: translateY(-122%);
  transition: transform 0.3s linear;
  ${transitionState === 'entered' ? `transform: translateY(0%);` : ''}
`;
function ModalStory(props) {
  const [isOpen, setIsOpen] = useState(props.isOpen);
  const scrollLock = useRef(new ScrollLock());
  function onClose() {
    setIsOpen(false);
    if (props.lock) {
      scrollLock.current.off();
    }
  }
  return /*#__PURE__*/React.createElement("div", {
    style: {
      height: '1500px'
    }
  }, /*#__PURE__*/React.createElement(Button, {
    onClick: () => {
      if (props.lock) {
        scrollLock.current.on();
      }
      setIsOpen(true);
    }
  }, "Open"), /*#__PURE__*/React.createElement(StyledModal, _extends({
    ariaLabel: "Storybook modal.",
    isOpen: isOpen,
    onClose: onClose
  }, props), /*#__PURE__*/React.createElement("div", {
    style: {
      height: '1000px'
    }
  }, "Content with 1000px height")));
}
export default {
  title: 'pcln-modal/Modal',
  component: Modal
};
export const Raw = () => /*#__PURE__*/React.createElement(ModalStory, {
  width: ['100px', '200px', '500px'],
  disableCloseButton: true
});
export const WithSmallModalHeader = () => /*#__PURE__*/React.createElement(ModalStory, {
  header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
  width: ['80vw', '400px', '500px']
});
export const WithModalHeader = () => {
  // Generate content to demonstrate a scrollable <body>
  const contentLines = [...Array(100).keys()];
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("h1", null, "Scroll down to open modal"), contentLines.map((i, idx) => /*#__PURE__*/React.createElement("div", {
    key: idx
  }, "Line ", idx)), /*#__PURE__*/React.createElement(ModalStory, {
    header: /*#__PURE__*/React.createElement(ModalHeader, {
      title: "Modal title",
      onClose: action('Modal closed!')
    }),
    height: ['90vh', '460px', '560px'],
    width: ['80vw', '400px', '500px']
  }));
};
export const WithSmallModalHeaderAndWhiteBackgroundModalHeaderWithSetTextStyle = () => {
  return /*#__PURE__*/React.createElement(ModalStory, {
    header: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(SmallModalHeader, {
      bg: null,
      color: "primary.base"
    }), /*#__PURE__*/React.createElement(ModalHeader, {
      bg: null,
      color: "background.lightest",
      onClose: action('Modal closed!'),
      pt: 2,
      textStyle: "heading4",
      title: "Modal title"
    })),
    height: ['90vh', '460px', '560px'],
    width: ['80vw', '400px', '500px']
  });
};
export const WithOverflow = () => /*#__PURE__*/React.createElement(ModalStory, {
  header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
  width: ['80vw', '400px', '500px'],
  enableOverflow: true
});
const accordionItems = [{
  headerLabel: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Text, null, "Header Label First Item")),
  content: /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Text, null, "I am some content"), /*#__PURE__*/React.createElement(Text, null, "I am some content"), /*#__PURE__*/React.createElement(Text, null, "I am some content")),
  value: 'item-1'
}];
export const WithOverflowForElementsRenderedInsideTheModal = () => /*#__PURE__*/React.createElement(StyledModal, {
  ariaLabel: "Storybook modal.",
  isOpen: true,
  height: "100px",
  enableOverflow: true
}, /*#__PURE__*/React.createElement(Accordion, {
  items: accordionItems
}));
export const WithOverflowAndDropdown = () => /*#__PURE__*/React.createElement(StyledModal, {
  ariaLabel: "Storybook modal.",
  isOpen: true,
  header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
  height: "100px"
}, /*#__PURE__*/React.createElement(Menu, {
  idx: "currency-selector",
  buttonNode: /*#__PURE__*/React.createElement("div", null, "open"),
  size: "twoColumns"
}, currencies.map((currency, index) => {
  const selected = 'USD' === currency.code;
  return /*#__PURE__*/React.createElement(MenuItem, {
    key: index,
    selected: selected
  }, /*#__PURE__*/React.createElement(Text, {
    regular: true,
    width: 32,
    textAlign: "center",
    mr: 3
  }, currency.symbol), /*#__PURE__*/React.createElement(Text, {
    regular: true
  }, currency.label));
})));
export const WithOverflowAndTallContent = () => /*#__PURE__*/React.createElement(StyledModal, {
  ariaLabel: "Storybook modal.",
  isOpen: true,
  header: /*#__PURE__*/React.createElement(ModalHeader, {
    onClose: action('Modal closed!')
  }),
  height: "100px",
  enableOverflow: true,
  disableCloseButton: true
}, /*#__PURE__*/React.createElement(Box, {
  color: "primary",
  height: "500px"
}, "Priceline"));
export const WithImagemodeAndColorful = () => /*#__PURE__*/React.createElement(ModalStory, {
  bg: "orange",
  header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
  width: ['100px', '200px', '500px'],
  imgMode: true,
  disableCloseButton: true
});
export const RoundedModalWithHeader = () => /*#__PURE__*/React.createElement(ModalStory, {
  bg: "orange",
  header: /*#__PURE__*/React.createElement(ModalHeader, {
    title: "Priceline"
  }),
  width: ['100px', '200px', '500px'],
  imgMode: true,
  disableCloseButton: true
});
export const WithCustomAnimation = () => /*#__PURE__*/React.createElement(ModalStory, {
  header: /*#__PURE__*/React.createElement(SmallModalHeader, null),
  width: ['100px', '200px', '500px'],
  dialogAnimation: CUSTOM_ANIMATION,
  verticalAlignment: "top"
});
export const ZeroTimeout = () => /*#__PURE__*/React.createElement(ModalStory, {
  disableCloseButton: true,
  width: ['100px', '200px', '500px'],
  timeout: 0
});